/***********************************************************************/
/*                                                                     */
/*  FILE        :LCD64128Spec.c                                        */
/*  DATE        :Tue, Jan 10, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :Other                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/*                                                                     */
/***********************************************************************/
                  


#include "ks0713.h"
#include "lcdg.h"
#include "sfr_r813.h"    
#include "tools.h"
#include "mathf.h"     

unsigned char ad_buf[256];                 
const signed char Sintab[256] ={0, 3, 6, 9, 12, 16, 19, 22, 25, 28, 31, 34, 37, 40, 43, 46, 49, 51, 54, 57, 60, 63, 65, 68, 71, 73, 76, 78, 81, 83, 85, 88, 90, 92, 94, 96, 98, 100, 102, 104, 106, 107, 109, 111, 112, 113, 115, 116, 117, 118, 120, 121, 122, 122, 123, 124, 125, 125, 126, 126, 126, 127, 127, 127, 127, 127, 127, 127, 126, 126, 126, 125, 125, 124, 123, 122, 122, 121, 120, 118, 117, 116, 115, 113, 112, 111, 109, 107, 106, 104, 102, 100, 98, 96, 94, 92, 90, 88, 85, 83, 81, 78, 76, 73, 71, 68, 65, 63, 60, 57, 54, 51, 49, 46, 43, 40, 37, 34, 31, 28, 25, 22, 19, 16, 12, 9, 6, 3, 0,-3,-6,-9,-12,-16,-19,-22,-25,-28,-31,-34,-37,-40,-43,-46,-49,-51,-54,-57,-60,-63,-65,-68,-71,-73,-76,-78,-81,-83,-85,-88,-90,-92,-94,-96,-98,-100,-102,-104,-106,-107,-109,-111,-112,-113,-115,-116,-117,-118,-120,-121,-122,-122,-123,-124,-125,-125,-126,-126,-126,-127,-127,-127,-127,-127,-127,-127,-126,-126,-126,-125,-125,-124,-123,-122,-122,-121,-120,-118,-117,-116,-115,-113,-112,-111,-109,-107,-106,-104,-102,-100,-98,-96,-94,-92,-90,-88,-85,-83,-81,-78,-76,-73,-71,-68,-65,-63,-60,-57,-54,-51,-49,-46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-12,-9,-6,-3};
                 

unsigned char ad_in(unsigned char ch)
{
    adcon0 = 0x80 + ch;     //Port P0 group 
    adcon1 = 0x20;          //8-bit mode 
    adst = 1;               //Conversion start 
    while(adst == 1){}      //Wait A/D conversion 
    return ad;              //AD value 
}

void trigger (void)
{
    int start;
	start = 0;
	while (p1_0 & !start)
	{
	  while (ad_in(6) > ad_in(5));
	  while (ad_in(6) < ad_in(5));
	  start = 1; 
	}
	while (p1_1 & !start)
	{
	  while (ad_in(6) < ad_in(5));
	  while (ad_in(6) > ad_in(5));
 	  start = 1; 
	}
}

void main(void)
{ 
  unsigned int adr;
  	unsigned char c, c_old;
	int r,i;
	unsigned int k,j;

  maxspeed();
  delay(10000); 
  lcdg_init();
  while (1)
  {
	for (adr = 0; adr < 256; adr++)
	{
	  ad_buf[adr] = (ad_in(6));
	}	 
	for (adr = 0; adr < 256; adr++)
	{
	  ad_buf[adr] = ((ad_buf[adr]-127)*(1 - cosf((float)adr * _PI / 128))/2+ 127);
	}	 
	ks0713_clrscr();	
	c_old = 0;
	for (k = 0; k < 128; k++)
	{
      r = 0;
      i = 0;
	  for (j = 0; j < 256; j++)
	  {
		 r = r + ((ad_buf[j]-127) *  Sintab[(k * j / 4) & 255]) / 128;
		 i = i + ((ad_buf[j]-127) * Sintab[(k * j / 4 + 64) & 255]) / 128;
	  }
	  r = (int)sqrtf(((float)r*(float)r+(float)i*(float)i)) ;   
	  c = r/ 200 ;
	  //c= ad_buf[k]/4;
	  lcdg_line(k, 63-c_old, k+1,63-c, BLACK);
	  c_old = c;
	}	
	delay(10000);
  }	 
}
