/***********************************************************************/
/*                                                                     */
/*  FILE        :Scope1.c                                              */
/*  DATE        :Thu, Jan 05, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :Other                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/*                                                                     */
/***********************************************************************/

#include "sfr_r813.h";          
unsigned char ad_buf[500];      

void UART0_init(void){
    p1 = p1 | 0x10;   // TxD0 port output 
    pd1 = pd1 | 0x10; // TxD0 port direction = output 
    pd1 = pd1 & 0xdf; // RxD0 port direction = input 
    u0mr = 0x05;      // UART0 transmit/receive mode 
    u0c0 = 0x00;      // UART0 transmit/receive control 
    u0rrm = 0;        // Continuous receive mode disabled 
    u0brg = 32-1;     // 38400 baud @20MHz 
    re_u0c1 = 1;      // Reception enabled 
}

void sendTxd0(unsigned char data)
{
	while (ti_u0c1 == 0);	//Wait for transmission buffer emty
	u0tbl = data;       	// Set transmission data 
    te_u0c1 = 1;        	// Transmission enabled 
}


unsigned char receiveRxd0 (void)
{
	unsigned char data;
	unsigned char dummy;
	while (ir_s0ric == 0); 	//Wait for received data
    ir_s0ric = 0;    		//Clear serial reception flag 
	data = u0rbl;     		// Get reception data 
	dummy = u0rbh;     		// Get error 
	re_u0c1 = 1;      		// Reception enabled 
	return data;
}

unsigned char ad_in(unsigned char ch)
{
    adcon0 = 0x80 + ch;     //Port P0 group 
    adcon1 = 0x20;          //8-bit mode 
    adst = 1;               //Conversion start 
    while(adst == 1){}      //Wait A/D conversion 
    return ad;              //AD value 
}

void sample(unsigned int ch)
{
	unsigned int adr;
	for (adr = 0; adr < 500; adr++)
	{
		ad_buf[adr] = ad_in(ch);
	}	 
	for (adr = 0; adr < 500; adr++)
	{
		sendTxd0(ad_buf[adr]);
	}	 
}
	              
void main(void)
{
    /*-------------------------------------------------
    -  Change on-chip oscillator clock to Main clock  -
    -------------------------------------------------*/

    prc0 = 1;           	/* Protect off */
    cm13 = 1;           	/* Xin Xout */
    cm15 = 1;           	/* XCIN-XCOUT drive capacity select bit : HIGH */
    cm05 = 0;           	/* Xin on */
    cm16 = 0;           	/* Main clock = No division mode */
    cm17 = 0;
    cm06 = 0;           	/* CM16 and CM17 enable */
    asm("nop");         	/* Waiting for stable of oscillation */
    asm("nop");
    asm("nop");
    asm("nop");
    ocd2 = 0;           	/* Main clock change */
    prc0 = 0;           	/* Protect on */
	UART0_init();  

	while (1)
	{  
	   sample(receiveRxd0());
	}
}


